# -*- coding: utf-8 -*-
from setuphelpers import *
import winshell


def remove_putty_if_install_with_exe():
    if uninstall_key_exists("PuTTY_is1"):
        killalltasks(control.impacted_process.split(","))
        # uninstaller cannot be silenced by design (cf putty.iss), so we remove stuff by hand
        # run('"%s" /VERYSILENT /SUPPRESSMSGBOXES' % os.path.join(programfiles32,'putty','unins000.exe'))
        if isdir(install_location("PuTTY_is1")):
            remove_tree(install_location("PuTTY_is1"))
        registry_delete(HKEY_LOCAL_MACHINE, "SOFTWARE\\Classes\\PuTTYPrivateKey", None)
        if iswin64():
            registry_delete(HKEY_LOCAL_MACHINE, "SOFTWARE\\Wow6432Node\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\PuTTY_is1", None)
        else:
            registry_delete(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\PuTTY_is1", None)
        putty_link = makepath(winshell.programs(common=1), "PuTTY")
        if isdir(putty_link):
            remove_tree(putty_link)
        unregister_uninstall("Putty_is1")


def install():
    # Initializing variables
    package_version = control.version.split("-", 1)[0]
    bin_name = "putty-64bit-%s-installer.msi" % package_version

    # Installing the package
    remove_putty_if_install_with_exe()
    print("Installing: %s" % bin_name)
    install_msi_if_needed(bin_name, min_version=package_version)

    #Uninstall old version putty
    for msi in installed_softwares('putty'):
        if not 'msiexec' in str(uninstall_cmd(msi['key'])).lower() :
            continue
        if Version(msi['version']) < package_version:
            run(uninstall_cmd(msi['key']))


def uninstall():
    # Uninstalling the package
    remove_putty_if_install_with_exe()
